/*
 * subdivision surface produit tensoriel
 */
#include <GLUT/glut.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define GRID_SIZE 3

GLenum doubleBuffer=GL_TRUE;
GLdouble Xrot = 0, Yrot = 0, Xtrans = 0.5, Ytrans = -0.5, Ztrans = 0;
GLint beginx, beginy, rotating = 0, xytranslating = 0, ztranslating = 0;
GLint xi=0,yi=0;

/* nombre d'etapes de subdivisions */
int s = 0;
int displaySurface = 0;
int displayLines = 1;
/* resolution apres s etapes de subdivision */
int ru, rv;

/* points de controles */
GLfloat grid[GRID_SIZE][GRID_SIZE][3];

int power_of_2(int s)
{
  int p = 1, i;
  for(i=0 ; i<s ; ++i) p *= 2;
  return p;
}

void init_grid()
{
  int i, j;
	
  /* Pour le cylindre */
  grid[0][0][0] = -5;
  grid[0][0][1] = 4;
  grid[0][0][2] = 0;
	
  grid[0][1][0] = 0;
  grid[0][1][1] = 4;
  grid[0][1][2] = 0;
	
  grid[0][2][0] = 5;
  grid[0][2][1] = 4;
  grid[0][2][2] = 0;
	
  grid[1][0][0] = -5;
  grid[1][0][1] = 2;
  grid[1][0][2] = 3;
	
  grid[1][1][0] = 0;
  grid[1][1][1] = 2;
  grid[1][1][2] = 3;

  grid[1][2][0] = 5;
  grid[1][2][1] = 2;
  grid[1][2][2] = 3;
	
  grid[2][0][0] = -5;
  grid[2][0][1] = 0;
  grid[2][0][2] = 0;
	
  grid[2][1][0] = 0;
  grid[2][1][1] = 0;
  grid[2][1][2] = 0;

  grid[2][2][0] = 5;
  grid[2][2][1] = 0;
  grid[2][2][2] = 0;

  /* Pour le tore; a dcommenter qd vous en avez besoin */
  /* 
     grid[0][0][0] = 7;
  grid[0][0][1] = 0;
  grid[0][0][2] = 0;
	
  grid[0][1][0] = 5;
  grid[0][1][1] = 0;
  grid[0][1][2] = 2.8;
	
  grid[0][2][0] = 3;
  grid[0][2][1] = 0;
  grid[0][2][2] = 0;
	
  grid[1][0][0] = -2.6;
  grid[1][0][1] = -4.4;
  grid[1][0][2] = 0;
	
  grid[1][1][0] = -2;
  grid[1][1][1] = -3;
  grid[1][1][2] = 2.8;

  grid[1][2][0] = -1.4;
  grid[1][2][1] = -1.6;
  grid[1][2][2] = 0;
	
  grid[2][0][0] = -2.6;
  grid[2][0][1] = 4.4;
  grid[2][0][2] = 0;
	
  grid[2][1][0] = -2;
  grid[2][1][1] = 3;
  grid[2][1][2] = 2.8;

  grid[2][2][0] = -1.4;
  grid[2][2][1] = 1.6;
  grid[2][2][2] = 0;
	
  */
}

/* Fonctions de Dessin */
void drawControlPoints()
{
  int i, j;
  glColor3f(1.0, 1.0, 0.0);
  glPointSize(5.0);
  glBegin(GL_POINTS);
  for(i=0 ; i<GRID_SIZE ; ++i)
    for(j=0 ; j<GRID_SIZE ; ++j)
      if(xi == i && yi == j)
	{
	  glColor3f(0.0, 0.7, 0.5);
	  glVertex3f(grid[i][j][0], grid[i][j][1], grid[i][j][2]);
	  glColor3f(1.0, 1.0, 0.0);
	} else
	glVertex3f(grid[i][j][0], grid[i][j][1], grid[i][j][2]);
  glEnd();
}

void calcul_resolution() {
  /* calcul de la resolution (ru x rv) apres s etapes de subdivision */
  int i;
  ru = rv = GRID_SIZE;
  for(i=0;i<s;++i) { ru*=2; rv*=2; }
}

void display() {
  int etape, i, j, current_u, current_v, i1, j1, coord;
	
  /* grille subdivisee sur les lignes */
  GLfloat grid_sub_l[ru][rv][3];
	
  /* grille subdivisee sur les lignes et colonnes */
  GLfloat grid_sub_lc[ru][rv][3];
  glEnable(GL_DEPTH_TEST);

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glPushMatrix();
  glRotatef(Yrot*180.0/M_PI , 0.0, -1.0, 0.0); /* deplacement */
  glRotatef(Xrot*180.0/M_PI , 1.0, 0.0, 0.0);  /* souris      */

  /* recopie de la grille originale dans grid_sub_lc */
  for(i=0 ; i<GRID_SIZE ; ++i)
    {
      for(j=0 ; j<GRID_SIZE ; ++j)
	{
	  grid_sub_lc[i][j][0] = grid[i][j][0];
	  grid_sub_lc[i][j][1] = grid[i][j][1];
	  grid_sub_lc[i][j][2] = grid[i][j][2];
	}
    }


  current_u = current_v = GRID_SIZE;
	
  /* On ralise s tapes de subdivision :*/
  for(etape=0; etape<s; etape++)
    {
      /* une tape : */

      /* C'est ici qu'il reste du travail... */
    }
	
  /* AFFICHAGE DE LA SURFACE SUBDIVISEE s FOIS */
  float specularLight[4];
  specularLight[0] = 2.0;
  specularLight[1] = 2.0;
  specularLight[2] = 2.0;
  specularLight[3] = 1.0;
  float diffuseLight[4];
  diffuseLight[0] = 0.8;
  diffuseLight[1] = 0.8;
  diffuseLight[2] = 0.9;
  diffuseLight[3] = 1.0;
  glPointSize(1.0);
  GLfloat light_position[4] = { 0.0, 3.0, 3.0, 1.0 };
  glLightfv(GL_LIGHT0, GL_POSITION, light_position);

  if (displaySurface) {
    glColor3f(0.8, 0.8, 0.8);
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_TRUE);
    glMaterialfv(GL_FRONT, GL_SPECULAR, specularLight);
    glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, diffuseLight);
    glMaterialf(GL_FRONT, GL_SHININESS, 39);
    /* affichage de la surface subdivise */
    for(i=0 ; i<current_u ; ++i) {
      glBegin(GL_QUAD_STRIP);
      for(j=0 ; j<current_v ; ++j)
	{
	  glVertex3f(grid_sub_lc[i][j][0], grid_sub_lc[i][j][1], grid_sub_lc[i][j][2]);
	  glVertex3f(grid_sub_lc[(i+1) % current_u][j][0], grid_sub_lc[(i+1) % current_u][j][1], grid_sub_lc[(i+1) % current_u][j][2]);
	}
      glEnd();
    }
    glDisable(GL_LIGHTING);
  }
  if (displayLines) { 
    /* lignes de surface subdivise en rouge */
    /* selon les colonnes */
    glColor3f(1.0, 0.0, 0.0);
    for(i=0 ; i < current_u ; ++i) {
      glBegin(GL_LINES);
      for(j=0 ; j< current_v-1 ; ++j)
	{
	   glVertex3f(grid_sub_lc[i][j][0], grid_sub_lc[i][j][1], grid_sub_lc[i][j][2]); 
	   glVertex3f(grid_sub_lc[i][j+1][0], grid_sub_lc[i][j+1][1], grid_sub_lc[i][j+1][2]); 
	}
      glEnd();
    }
    /* selon les lignes */
    for(j=0 ; j<current_v ; ++j) {
      glBegin(GL_LINE_LOOP);
      for(i=0 ; i<current_u ; ++i)
	{
	   glVertex3f(grid_sub_lc[i][j][0], grid_sub_lc[i][j][1], grid_sub_lc[i][j][2]); 
	}
      glEnd();
    }
  }
  drawControlPoints();
  glPopMatrix();
  glFlush();
  if(doubleBuffer) glutSwapBuffers();
}



/* Fonction de gestion de l'evenement click d'un bouton de la souris */
void mouse(int button, int state, int x, int y)
{
  if (button == GLUT_LEFT_BUTTON && state == GLUT_DOWN) {
    rotating = 1;
    beginx = x;
    beginy = y;
  }
  if (button == GLUT_LEFT_BUTTON && state == GLUT_UP) {
    rotating = 0;
  }

  if (button == GLUT_RIGHT_BUTTON && state == GLUT_DOWN) {
    ztranslating = 1;
    beginx = x;
    beginy = y;
  }
  if (button == GLUT_RIGHT_BUTTON && state == GLUT_UP) {
    ztranslating = 0;
  }
}

/* Fonction de gestion de l'evenement deplacement de la souris */
void mouseMotion(int x, int y)
{
  if (rotating) {
    Xrot = Xrot + (y - beginy) / 100.0 ;
    Yrot = Yrot - (x - beginx) / 100.0 ;
    beginx = x;
    beginy = y;
    display();
  }

  if (ztranslating) {
    grid[xi][yi][2] -= ((double)(y - beginy)/10.0);
    beginx = x;
    beginy = y;
    glutPostRedisplay();
  }
}


/* Fonction de test de touche du clavier */
static void key( unsigned char key, int x, int y )
{
  switch (key) {
  case 27:               /* sortie si ESC */
    exit(0);
  case '+':
    s++; calcul_resolution();
    printf("nombre d'etapes de subdivision : %d; resolution : %d x %d\n", s, ru, rv);
    glutPostRedisplay();
    break;
  case '-':
    if(s>0) s--; calcul_resolution();
    printf("nombre d'etapes de subdivision : %d; resolution : %d x %d\n", s, ru, rv);
    glutPostRedisplay();
    break;
  case 's':
    displaySurface = !(displaySurface);
    glutPostRedisplay();
    break;
  case 'l':
    displayLines = !(displayLines);
    glutPostRedisplay();
    break;
  }
}

static void SpecialKey( int key, int x, int y )
{
  switch (key) {      
  case GLUT_KEY_LEFT:
    yi =  yi > 0 ? yi - 1 : GRID_SIZE -1 ;display();
    break ;
  case GLUT_KEY_RIGHT:
    yi = (yi + 1)%GRID_SIZE;display();
    break;
  case GLUT_KEY_UP:
    xi = (xi +1)%GRID_SIZE;display();
    break ;
  case GLUT_KEY_DOWN:
    xi =  xi > 0 ? xi - 1 : GRID_SIZE -1;display();
    break;
  }
}


/* Fonction de reaffichage */
static void reshape(GLsizei w, GLsizei h)
{
  glViewport(0, 0, w, h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glFrustum(-5.0, 5, -5.0, 5, 10.0, 50.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glTranslatef(0,0,-20);
}


/*  Main Loop
 *  Ouverture de la fenetre d'affichage de tailles et titre donnes 
 *  et definition des fonctions de gestion d'evenement.
 */
int main(int argc, char** argv)
{
  GLenum type;      
  
  glutInit(&argc, argv);
  glutInitWindowSize (400, 400);
  init_grid();
  
  type = GLUT_RGB;
  type |= (doubleBuffer) ? GLUT_DOUBLE : GLUT_SINGLE;
  glutInitDisplayMode(type | GLUT_DEPTH);
  if (glutCreateWindow("Subdivision surface produit tensoriel") == GL_FALSE) {
    exit(1);
  }
  printf("\n\nNombre d'etapes de subdivision : '+' et '-' ;\nMouvement point de vue : bouton gauche souris ; \nMouvement point controle selectionne : bouton droit (z) souris ;\nSelection point de controle : fleches \n");

  calcul_resolution();
  glClearColor (0.0, 0.1, 0.2, 0.0);
  glutMouseFunc(mouse);
  glutMotionFunc(mouseMotion);
  glutKeyboardFunc(key);
  glutSpecialFunc(SpecialKey);
  glutDisplayFunc(display);
  glutReshapeFunc(reshape);
  glutMainLoop();
  return 0;
}
